


















































































































 


































































































































































 










































































































































































































 



















































 










 








































































































































































































































 










                                
                                

                                
                                

                                
                                

                                



















































































  

  subroutine NullExact_PreCalcYlm(cctk_dim,cctk_gsh,cctk_lsh,cctk_lbnd,cctk_ubnd,cctk_tile_min,cctk_tile_max,cctk_ash,cctk_alignmen&
  &t,cctk_alignment_offset,cctk_from,cctk_to,cctk_bbox,cctk_delta_time,cctk_time,cctk_delta_space,cctk_origin_space,cctk_levfac,cct&
  &k_levoff,cctk_levoffdenom,cctk_timefac,cctk_convlevel,cctk_convfac,cctk_nghostzones,cctk_iteration,cctkGH,cctk_ash1,cctk_ash2,cc&
  &tk_ash3, J_l_err_length,NewsB_e_length,NewsBi_e_length,NewsBi_length,NewsBr_e_length,NewsBr_length,News_MoL_length,Newsi_e_lengt&
  &h,Newsr_e_length,Psi4_e_length,Psi4i_e_length,Psi4r_e_length,X0J_l_err,X0NewsB_e,X0NewsBi,X0NewsBi_e,X0NewsBr,X0NewsBr_e,X0News_&
  &MoL,X0Newsi_e,X0Newsr_e,X0Psi4_e,X0Psi4i_e,X0Psi4r_e,X0WTexact_mask,X0Ylm_group,X0ana_J,X0ana_J_l,X0ana_News,X0ana_Psi4,X0ana_Q,&
  &X0ana_U,X0ana_mu,X0cmplxcharfuncs_aux_e,X0cmplxcharfuncs_aux_e_south,X0cmplxcharfuncs_basic_e,X0cmplxcharfuncs_basic_e_mask,X0cm&
  &plxcharfuncs_basic_e_south,X0cmplxcharfuncs_basic_e_split,X0dotNews_MoL,X0errNews_MoL,X0hJ_l,X0hmu,X0mu_err,X0num_J_l,X0realCons&
  &tr_e,X0realcharfuncs_e,X0realcharfuncs_e_south,X0uBondi_e,X1J_l_err,X1NewsB_e,X1NewsBi,X1NewsBi_e,X1NewsBr,X1NewsBr_e,X1News_MoL&
  &,X1Newsi_e,X1Newsr_e,X1Psi4_e,X1Psi4i_e,X1Psi4r_e,X1WTexact_mask,X1Ylm_group,X1ana_J,X1ana_J_l,X1ana_News,X1ana_Psi4,X1ana_Q,X1a&
  &na_U,X1ana_mu,X1cmplxcharfuncs_aux_e,X1cmplxcharfuncs_aux_e_south,X1cmplxcharfuncs_basic_e,X1cmplxcharfuncs_basic_e_mask,X1cmplx&
  &charfuncs_basic_e_south,X1cmplxcharfuncs_basic_e_split,X1dotNews_MoL,X1errNews_MoL,X1hJ_l,X1hmu,X1mu_err,X1num_J_l,X1realConstr_&
  &e,X1realcharfuncs_e,X1realcharfuncs_e_south,X1uBondi_e,Ylm_group_length,ana_J_l_length,ana_J_length,ana_News_length,ana_Psi4_len&
  &gth,ana_Q_length,ana_U_length,ana_mu_length,cmplxcharfuncs_aux_e_length,cmplxcharfuncs_aux_e_south_length,cmplxcharfuncs_basic_e&
  &_length,cmplxcharfuncs_basic_e_mask_length,cmplxcharfuncs_basic_e_south_length,cmplxcharfuncs_basic_e_split_length,dotNews_MoL_l&
  &ength,errNews_MoL_length,hJ_l_length,hmu_length,mu_err_length,num_J_l_length,realConstr_e_length,realcharfuncs_e_length,realchar&
  &funcs_e_south_length,uBondi_e_length,EGaJ_l_e,EGmu_e,EGnJ_l_e,EQJh_l,EQmuh,Jh_l,Meth2jcn_e,Mjcn_e,Mucn_e,NewsB_e,NewsBi,NewsBi_e&
  &,NewsBr,NewsBr_e,News_MoL,News_MoL_p,Newsi_e,Newsr_e,Psi4_e,Psi4i_e,Psi4r_e,R01n_e,R01s_e,WTexact_maskn,WTexact_masks,Ylm_0,Ylm_&
  &1,Ylm_2,aJ_l_e,ana_J_l,ana_News,ana_Psi4,ana_jcn,ana_jcs,ana_mu,ana_qcn,ana_qcs,ana_ucn,ana_ucs,bcn_e,bcs_e,cbcn_e,cbcs_e,ckcn_e&
  &,ckcs_e,dotNews_MoL,dotNews_MoL_p,errNews_MoL,eth2jcn_e,eth2jcs_e,jcn_e,jcni,jcni_e,jcnr,jcnr_e,jcs_e,mu_e,muh,nJ_l_e,nucn_e,nuc&
  &s_e,num_J_l,qcn_e,qcs_e,uBondi_e,ucn_e,ucs_e,wcn_e,wcs_e, SHRE_alpha_e_length,SHRE_beta_e_length,SHRE_dalpha_e_length,SHRE_dbeta&
  &_e_length,SHRE_dgij_e_length,SHRE_dgit_e_length,SHRE_gij_e_length,SHRE_git_e_length,WT_r0_length,X0SHRE_alpha_e,X0SHRE_beta_e,X0&
  &SHRE_dalpha_e,X0SHRE_dbeta_e,X0SHRE_dgij_e,X0SHRE_dgit_e,X0SHRE_gij_e,X0SHRE_git_e,X0WT_r0,X0beta_l,X0beta_wt,X0j_l,X0j_wt,X0q_w&
  &t,X0u_l,X0u_wt,X0u_x_wt,X0w_l,X0w_wt,X0x_wt,X1SHRE_alpha_e,X1SHRE_beta_e,X1SHRE_dalpha_e,X1SHRE_dbeta_e,X1SHRE_dgij_e,X1SHRE_dgi&
  &t_e,X1SHRE_gij_e,X1SHRE_git_e,X1WT_r0,X1beta_l,X1beta_wt,X1j_l,X1j_wt,X1q_wt,X1u_l,X1u_wt,X1u_x_wt,X1w_l,X1w_wt,X1x_wt,beta_l_le&
  &ngth,beta_wt_length,j_l_length,j_wt_length,q_wt_length,u_l_length,u_wt_length,u_x_wt_length,w_l_length,w_wt_length,x_wt_length,S&
  &HRE_alpha_e,SHRE_beta_e,SHRE_dpalpha_e,SHRE_dpbeta_e,SHRE_dpgij_e,SHRE_dpgit_e,SHRE_dqalpha_e,SHRE_dqbeta_e,SHRE_dqgij_e,SHRE_dq&
  &git_e,SHRE_dralpha_e,SHRE_drbeta_e,SHRE_drgij_e,SHRE_drgit_e,SHRE_dtalpha_e,SHRE_dtbeta_e,SHRE_dtgij_e,SHRE_dtgit_e,SHRE_gij_e,S&
  &HRE_git_e,WT_r0,beta_l,beta_wt,beta_wt_p,j_l,j_wt,j_wt_p,q_wt,q_wt_p,u_l,u_wt,u_wt_p,u_x_wt,w_l,w_wt,w_wt_p,x_wt,x_wt_p, JJ_l_le&
  &ngth,NewsB_length,NewsB_past_length,NewsB_uBondi_length,News_length,News_past_length,News_uBondi_length,Null_AuxConstr_length,Nu&
  &ll_AuxConstr_south_length,Null_R00_length,Null_R00_south_length,Null_R01_length,Null_R01_south_length,Null_R0A_length,Null_R0A_s&
  &outh_length,Null_R0A_split_length,Psi4_length,Psi4_past_length,Psi4_uBondi_length,X0EG_mask,X0EQ_mask,X0EV_mask,X0JJ_l,X0News,X0&
  &NewsB,X0NewsB_past,X0NewsB_uBondi,X0News_past,X0News_uBondi,X0NullGrParArrI,X0NullGrParArrR,X0Null_AuxConstr,X0Null_AuxConstr_so&
  &uth,X0Null_R00,X0Null_R00_south,X0Null_R01,X0Null_R01_south,X0Null_R0A,X0Null_R0A_south,X0Null_R0A_split,X0Psi4,X0Psi4_past,X0Ps&
  &i4_uBondi,X0RadCrd,X0StCmCrd,X0StCrd,X0cmplxcharfuncs_aux,X0cmplxcharfuncs_basic,X0guard_mask,X0linStrain,X0linStrain_past,X0lin&
  &Strain_uBondi,X0null_mask,X0omega,X0realcharfuncs,X0tmp_cgf,X0tmp_cgf3,X0tmp_rgf,X0uBondi,X0uBondi_past,X1EG_mask,X1EQ_mask,X1EV&
  &_mask,X1JJ_l,X1News,X1NewsB,X1NewsB_past,X1NewsB_uBondi,X1News_past,X1News_uBondi,X1Null_AuxConstr,X1Null_AuxConstr_south,X1Null&
  &_R00,X1Null_R00_south,X1Null_R01,X1Null_R01_south,X1Null_R0A,X1Null_R0A_south,X1Null_R0A_split,X1Psi4,X1Psi4_past,X1Psi4_uBondi,&
  &X1StCmCrd,X1StCrd,X1cmplxcharfuncs_aux,X1cmplxcharfuncs_basic,X1guard_mask,X1linStrain,X1linStrain_past,X1linStrain_uBondi,X1nul&
  &l_mask,X1omega,X1realcharfuncs,X1tmp_cgf,X1tmp_cgf3,X1tmp_rgf,X1uBondi,X1uBondi_past,cmplxcharfuncs_aux_length,cmplxcharfuncs_ba&
  &sic_length,linStrain_length,linStrain_past_length,linStrain_uBondi_length,omega_length,realcharfuncs_length,uBondi_length,uBondi&
  &_past_length,EG_mask,EQ_mask,EV_mask,Jn_l,Jo_l,News,NewsB,NewsB_past,NewsB_uBondi,News_past,News_uBondi,Null_AuxConstr_cbcn,Null&
  &_AuxConstr_cbcs,Null_AuxConstr_ckcn,Null_AuxConstr_ckcs,Null_AuxConstr_nucn,Null_AuxConstr_nucs,Null_R00,Null_R00_south,Null_R01&
  &,Null_R01_south,Null_R0A,Null_R0A_i,Null_R0A_r,Null_R0A_south,Psi4,Psi4_past,Psi4_uBondi,bcn,bcn_p,bcs,bcs_p,boundary_maskn,boun&
  &dary_masks,cbcn,cbcn_p,cbcs,cbcs_p,ckcn,ckcn_p,ckcs,ckcs_p,constant_uBondi,courant_min_time,courant_wave_speed,dxjcn,dxjcn_p,dxj&
  &cs,dxjcs_p,eth2jcn,eth2jcn_p,eth2jcs,eth2jcs_p,evolution_maskn,evolution_masks,evolution_radius,guard_mask,jcn,jcn_p,jcs,jcs_p,l&
  &inStrain,linStrain_past,linStrain_uBondi,nucn,nucn_p,nucs,nucs_p,null_delta,null_dx,null_gsh,null_lbnd,null_lsh,null_rb,null_rbh&
  &,null_ubnd,null_xb,null_xbh,omegan,omegao,qcn,qcn_p,qcs,qcs_p,qsize,stereo_p,stereo_pp,stereo_q,time_of_news,tmp_cgfn,tmp_cgfn1,&
  &tmp_cgfn2,tmp_cgfn3,tmp_cgfs,tmp_cgfs1,tmp_cgfs2,tmp_cgfs3,tmp_rgfn,tmp_rgfs,uBondi,uBondi_past,ucn,ucn_p,ucs,ucs_p,wcn,wcn_p,wc&
  &s,wcs_p,zeta)

    use cctk
    use NullEvol_sYlm
    use NullGrid_Vars
    implicit none


  INTEGER cctk_dim
  integer, parameter :: cctki_use_cctk_dim = kind(cctk_dim)
  INTEGER cctk_gsh (cctk_dim)
  integer, parameter :: cctki_use_cctk_gsh = kind(cctk_gsh)
  INTEGER cctk_lsh (cctk_dim)
  integer, parameter :: cctki_use_cctk_lsh = kind(cctk_lsh)
  INTEGER cctk_lbnd (cctk_dim)
  integer, parameter :: cctki_use_cctk_lbnd = kind(cctk_lbnd)
  INTEGER cctk_ubnd (cctk_dim)
  integer, parameter :: cctki_use_cctk_ubnd = kind(cctk_ubnd)
  INTEGER cctk_tile_min (cctk_dim)
  integer, parameter :: cctki_use_cctk_tile_min = kind(cctk_tile_min)
  INTEGER cctk_tile_max (cctk_dim)
  integer, parameter :: cctki_use_cctk_tile_max = kind(cctk_tile_max)
  INTEGER cctk_ash (cctk_dim)
  integer, parameter :: cctki_use_cctk_ash = kind(cctk_ash)
  INTEGER cctk_alignment
  integer, parameter :: cctki_use_cctk_alignment = kind(cctk_alignment)
  INTEGER cctk_alignment_offset
  integer, parameter :: cctki_use_cctk_alignment_offset = kind(cctk_alignment_offset)
  INTEGER cctk_from (cctk_dim)
  integer, parameter :: cctki_use_cctk_from = kind(cctk_from)
  INTEGER cctk_to (cctk_dim)
  integer, parameter :: cctki_use_cctk_to = kind(cctk_to)
  INTEGER cctk_bbox (2*cctk_dim)
  integer, parameter :: cctki_use_cctk_bbox = kind(cctk_bbox)
  REAL*8 cctk_delta_time
  integer, parameter :: cctki_use_cctk_delta_time = kind(cctk_delta_time)
  REAL*8 cctk_time
  integer, parameter :: cctki_use_cctk_time = kind(cctk_time)
  REAL*8 cctk_delta_space (cctk_dim)
  integer, parameter :: cctki_use_cctk_delta_space = kind(cctk_delta_space)
  REAL*8 cctk_origin_space (cctk_dim)
  integer, parameter :: cctki_use_cctk_origin_space = kind(cctk_origin_space)
  INTEGER cctk_levfac (cctk_dim)
  integer, parameter :: cctki_use_cctk_levfac = kind(cctk_levfac)
  INTEGER cctk_levoff (cctk_dim)
  integer, parameter :: cctki_use_cctk_levoff = kind(cctk_levoff)
  INTEGER cctk_levoffdenom (cctk_dim)
  integer, parameter :: cctki_use_cctk_levoffdenom = kind(cctk_levoffdenom)
  INTEGER cctk_timefac
  integer, parameter :: cctki_use_cctk_timefac = kind(cctk_timefac)
  INTEGER cctk_convlevel
  integer, parameter :: cctki_use_cctk_convlevel = kind(cctk_convlevel)
  INTEGER cctk_convfac
  integer, parameter :: cctki_use_cctk_convfac = kind(cctk_convfac)
  INTEGER cctk_nghostzones (cctk_dim)
  integer, parameter :: cctki_use_cctk_nghostzones = kind(cctk_nghostzones)
  INTEGER cctk_iteration
  integer, parameter :: cctki_use_cctk_iteration = kind(cctk_iteration)
  integer*8 cctkGH
  integer, parameter :: cctki_use_cctkGH = kind(cctkGH)
  INTEGER cctk_ash1
  integer, parameter :: cctki_use_cctk_ash1 = kind(cctk_ash1)
  INTEGER cctk_ash2
  integer, parameter :: cctki_use_cctk_ash2 = kind(cctk_ash2)
  INTEGER cctk_ash3
  integer, parameter :: cctki_use_cctk_ash3 = kind(cctk_ash3)
  INTEGER J_l_err_length
  INTEGER NewsB_e_length
  INTEGER NewsBi_e_length
  INTEGER NewsBi_length
  INTEGER NewsBr_e_length
  INTEGER NewsBr_length
  INTEGER News_MoL_length
  INTEGER Newsi_e_length
  INTEGER Newsr_e_length
  INTEGER Psi4_e_length
  INTEGER Psi4i_e_length
  INTEGER Psi4r_e_length
  INTEGER X0J_l_err
  INTEGER X0NewsB_e
  INTEGER X0NewsBi
  INTEGER X0NewsBi_e
  INTEGER X0NewsBr
  INTEGER X0NewsBr_e
  INTEGER X0News_MoL
  INTEGER X0Newsi_e
  INTEGER X0Newsr_e
  INTEGER X0Psi4_e
  INTEGER X0Psi4i_e
  INTEGER X0Psi4r_e
  INTEGER X0WTexact_mask
  INTEGER X0Ylm_group
  INTEGER X0ana_J
  INTEGER X0ana_J_l
  INTEGER X0ana_News
  INTEGER X0ana_Psi4
  INTEGER X0ana_Q
  INTEGER X0ana_U
  INTEGER X0ana_mu
  INTEGER X0cmplxcharfuncs_aux_e
  INTEGER X0cmplxcharfuncs_aux_e_south
  INTEGER X0cmplxcharfuncs_basic_e
  INTEGER X0cmplxcharfuncs_basic_e_mask
  INTEGER X0cmplxcharfuncs_basic_e_south
  INTEGER X0cmplxcharfuncs_basic_e_split
  INTEGER X0dotNews_MoL
  INTEGER X0errNews_MoL
  INTEGER X0hJ_l
  INTEGER X0hmu
  INTEGER X0mu_err
  INTEGER X0num_J_l
  INTEGER X0realConstr_e
  INTEGER X0realcharfuncs_e
  INTEGER X0realcharfuncs_e_south
  INTEGER X0uBondi_e
  INTEGER X1J_l_err
  INTEGER X1NewsB_e
  INTEGER X1NewsBi
  INTEGER X1NewsBi_e
  INTEGER X1NewsBr
  INTEGER X1NewsBr_e
  INTEGER X1News_MoL
  INTEGER X1Newsi_e
  INTEGER X1Newsr_e
  INTEGER X1Psi4_e
  INTEGER X1Psi4i_e
  INTEGER X1Psi4r_e
  INTEGER X1WTexact_mask
  INTEGER X1Ylm_group
  INTEGER X1ana_J
  INTEGER X1ana_J_l
  INTEGER X1ana_News
  INTEGER X1ana_Psi4
  INTEGER X1ana_Q
  INTEGER X1ana_U
  INTEGER X1ana_mu
  INTEGER X1cmplxcharfuncs_aux_e
  INTEGER X1cmplxcharfuncs_aux_e_south
  INTEGER X1cmplxcharfuncs_basic_e
  INTEGER X1cmplxcharfuncs_basic_e_mask
  INTEGER X1cmplxcharfuncs_basic_e_south
  INTEGER X1cmplxcharfuncs_basic_e_split
  INTEGER X1dotNews_MoL
  INTEGER X1errNews_MoL
  INTEGER X1hJ_l
  INTEGER X1hmu
  INTEGER X1mu_err
  INTEGER X1num_J_l
  INTEGER X1realConstr_e
  INTEGER X1realcharfuncs_e
  INTEGER X1realcharfuncs_e_south
  INTEGER X1uBondi_e
  INTEGER Ylm_group_length
  INTEGER ana_J_l_length
  INTEGER ana_J_length
  INTEGER ana_News_length
  INTEGER ana_Psi4_length
  INTEGER ana_Q_length
  INTEGER ana_U_length
  INTEGER ana_mu_length
  INTEGER cmplxcharfuncs_aux_e_length
  INTEGER cmplxcharfuncs_aux_e_south_length
  INTEGER cmplxcharfuncs_basic_e_length
  INTEGER cmplxcharfuncs_basic_e_mask_length
  INTEGER cmplxcharfuncs_basic_e_south_length
  INTEGER cmplxcharfuncs_basic_e_split_length
  INTEGER dotNews_MoL_length
  INTEGER errNews_MoL_length
  INTEGER hJ_l_length
  INTEGER hmu_length
  INTEGER mu_err_length
  INTEGER num_J_l_length
  INTEGER realConstr_e_length
  INTEGER realcharfuncs_e_length
  INTEGER realcharfuncs_e_south_length
  INTEGER uBondi_e_length
  COMPLEX*16 EGaJ_l_e (X0J_l_err,X1J_l_err,J_l_err_length)
  integer, parameter :: cctki_use_EGaJ_l_e = kind(EGaJ_l_e)
  REAL*8 EGmu_e (X0mu_err,X1mu_err,mu_err_length)
  integer, parameter :: cctki_use_EGmu_e = kind(EGmu_e)
  COMPLEX*16 EGnJ_l_e (X0J_l_err,X1J_l_err,J_l_err_length)
  integer, parameter :: cctki_use_EGnJ_l_e = kind(EGnJ_l_e)
  COMPLEX*16 EQJh_l (X0hJ_l,X1hJ_l,hJ_l_length)
  integer, parameter :: cctki_use_EQJh_l = kind(EQJh_l)
  REAL*8 EQmuh (X0hmu,X1hmu,hmu_length)
  integer, parameter :: cctki_use_EQmuh = kind(EQmuh)
  COMPLEX*16 Jh_l (X0hJ_l,X1hJ_l,hJ_l_length)
  integer, parameter :: cctki_use_Jh_l = kind(Jh_l)
  COMPLEX*16 Meth2jcn_e (X0cmplxcharfuncs_basic_e_mask,X1cmplxcharfuncs_basic_e_mask,cmplxcharfuncs_basic_e_mask_length)
  integer, parameter :: cctki_use_Meth2jcn_e = kind(Meth2jcn_e)
  COMPLEX*16 Mjcn_e (X0cmplxcharfuncs_basic_e_mask,X1cmplxcharfuncs_basic_e_mask,cmplxcharfuncs_basic_e_mask_length)
  integer, parameter :: cctki_use_Mjcn_e = kind(Mjcn_e)
  COMPLEX*16 Mucn_e (X0cmplxcharfuncs_basic_e_mask,X1cmplxcharfuncs_basic_e_mask,cmplxcharfuncs_basic_e_mask_length)
  integer, parameter :: cctki_use_Mucn_e = kind(Mucn_e)
  COMPLEX*16 NewsB_e (X0NewsB_e,X1NewsB_e,NewsB_e_length)
  integer, parameter :: cctki_use_NewsB_e = kind(NewsB_e)
  REAL*8 NewsBi (X0NewsBi,X1NewsBi,NewsBi_length)
  integer, parameter :: cctki_use_NewsBi = kind(NewsBi)
  REAL*8 NewsBi_e (X0NewsBi_e,X1NewsBi_e,NewsBi_e_length)
  integer, parameter :: cctki_use_NewsBi_e = kind(NewsBi_e)
  REAL*8 NewsBr (X0NewsBr,X1NewsBr,NewsBr_length)
  integer, parameter :: cctki_use_NewsBr = kind(NewsBr)
  REAL*8 NewsBr_e (X0NewsBr_e,X1NewsBr_e,NewsBr_e_length)
  integer, parameter :: cctki_use_NewsBr_e = kind(NewsBr_e)
  REAL*8 News_MoL (X0News_MoL,X1News_MoL,News_MoL_length)
  integer, parameter :: cctki_use_News_MoL = kind(News_MoL)
  REAL*8 News_MoL_p (X0News_MoL,X1News_MoL,News_MoL_length)
  integer, parameter :: cctki_use_News_MoL_p = kind(News_MoL_p)
  REAL*8 Newsi_e (X0Newsi_e,X1Newsi_e,Newsi_e_length)
  integer, parameter :: cctki_use_Newsi_e = kind(Newsi_e)
  REAL*8 Newsr_e (X0Newsr_e,X1Newsr_e,Newsr_e_length)
  integer, parameter :: cctki_use_Newsr_e = kind(Newsr_e)
  COMPLEX*16 Psi4_e (X0Psi4_e,X1Psi4_e,Psi4_e_length)
  integer, parameter :: cctki_use_Psi4_e = kind(Psi4_e)
  REAL*8 Psi4i_e (X0Psi4i_e,X1Psi4i_e,Psi4i_e_length)
  integer, parameter :: cctki_use_Psi4i_e = kind(Psi4i_e)
  REAL*8 Psi4r_e (X0Psi4r_e,X1Psi4r_e,Psi4r_e_length)
  integer, parameter :: cctki_use_Psi4r_e = kind(Psi4r_e)
  REAL*8 R01n_e (X0realConstr_e,X1realConstr_e,realConstr_e_length)
  integer, parameter :: cctki_use_R01n_e = kind(R01n_e)
  REAL*8 R01s_e (X0realConstr_e,X1realConstr_e,realConstr_e_length)
  integer, parameter :: cctki_use_R01s_e = kind(R01s_e)
  INTEGER*4 WTexact_maskn (X0WTexact_mask,X1WTexact_mask)
  integer, parameter :: cctki_use_WTexact_maskn = kind(WTexact_maskn)
  INTEGER*4 WTexact_masks (X0WTexact_mask,X1WTexact_mask)
  integer, parameter :: cctki_use_WTexact_masks = kind(WTexact_masks)
  COMPLEX*16 Ylm_0 (X0Ylm_group,X1Ylm_group,Ylm_group_length)
  integer, parameter :: cctki_use_Ylm_0 = kind(Ylm_0)
  COMPLEX*16 Ylm_1 (X0Ylm_group,X1Ylm_group,Ylm_group_length)
  integer, parameter :: cctki_use_Ylm_1 = kind(Ylm_1)
  COMPLEX*16 Ylm_2 (X0Ylm_group,X1Ylm_group,Ylm_group_length)
  integer, parameter :: cctki_use_Ylm_2 = kind(Ylm_2)
  COMPLEX*16 aJ_l_e (X0J_l_err,X1J_l_err,J_l_err_length)
  integer, parameter :: cctki_use_aJ_l_e = kind(aJ_l_e)
  COMPLEX*16 ana_J_l (X0ana_J_l,X1ana_J_l,ana_J_l_length)
  integer, parameter :: cctki_use_ana_J_l = kind(ana_J_l)
  COMPLEX*16 ana_News (X0ana_News,X1ana_News,ana_News_length)
  integer, parameter :: cctki_use_ana_News = kind(ana_News)
  COMPLEX*16 ana_Psi4 (X0ana_Psi4,X1ana_Psi4,ana_Psi4_length)
  integer, parameter :: cctki_use_ana_Psi4 = kind(ana_Psi4)
  COMPLEX*16 ana_jcn (X0ana_J,X1ana_J,ana_J_length)
  integer, parameter :: cctki_use_ana_jcn = kind(ana_jcn)
  COMPLEX*16 ana_jcs (X0ana_J,X1ana_J,ana_J_length)
  integer, parameter :: cctki_use_ana_jcs = kind(ana_jcs)
  REAL*8 ana_mu (X0ana_mu,X1ana_mu,ana_mu_length)
  integer, parameter :: cctki_use_ana_mu = kind(ana_mu)
  COMPLEX*16 ana_qcn (X0ana_Q,X1ana_Q,ana_Q_length)
  integer, parameter :: cctki_use_ana_qcn = kind(ana_qcn)
  COMPLEX*16 ana_qcs (X0ana_Q,X1ana_Q,ana_Q_length)
  integer, parameter :: cctki_use_ana_qcs = kind(ana_qcs)
  COMPLEX*16 ana_ucn (X0ana_U,X1ana_U,ana_U_length)
  integer, parameter :: cctki_use_ana_ucn = kind(ana_ucn)
  COMPLEX*16 ana_ucs (X0ana_U,X1ana_U,ana_U_length)
  integer, parameter :: cctki_use_ana_ucs = kind(ana_ucs)
  REAL*8 bcn_e (X0realcharfuncs_e,X1realcharfuncs_e,realcharfuncs_e_length)
  integer, parameter :: cctki_use_bcn_e = kind(bcn_e)
  REAL*8 bcs_e (X0realcharfuncs_e_south,X1realcharfuncs_e_south,realcharfuncs_e_south_length)
  integer, parameter :: cctki_use_bcs_e = kind(bcs_e)
  COMPLEX*16 cbcn_e (X0cmplxcharfuncs_aux_e,X1cmplxcharfuncs_aux_e,cmplxcharfuncs_aux_e_length)
  integer, parameter :: cctki_use_cbcn_e = kind(cbcn_e)
  COMPLEX*16 cbcs_e (X0cmplxcharfuncs_aux_e_south,X1cmplxcharfuncs_aux_e_south,cmplxcharfuncs_aux_e_south_length)
  integer, parameter :: cctki_use_cbcs_e = kind(cbcs_e)
  COMPLEX*16 ckcn_e (X0cmplxcharfuncs_aux_e,X1cmplxcharfuncs_aux_e,cmplxcharfuncs_aux_e_length)
  integer, parameter :: cctki_use_ckcn_e = kind(ckcn_e)
  COMPLEX*16 ckcs_e (X0cmplxcharfuncs_aux_e_south,X1cmplxcharfuncs_aux_e_south,cmplxcharfuncs_aux_e_south_length)
  integer, parameter :: cctki_use_ckcs_e = kind(ckcs_e)
  REAL*8 dotNews_MoL (X0dotNews_MoL,X1dotNews_MoL,dotNews_MoL_length)
  integer, parameter :: cctki_use_dotNews_MoL = kind(dotNews_MoL)
  REAL*8 dotNews_MoL_p (X0dotNews_MoL,X1dotNews_MoL,dotNews_MoL_length)
  integer, parameter :: cctki_use_dotNews_MoL_p = kind(dotNews_MoL_p)
  REAL*8 errNews_MoL (X0errNews_MoL,X1errNews_MoL,errNews_MoL_length)
  integer, parameter :: cctki_use_errNews_MoL = kind(errNews_MoL)
  COMPLEX*16 eth2jcn_e (X0cmplxcharfuncs_basic_e,X1cmplxcharfuncs_basic_e,cmplxcharfuncs_basic_e_length)
  integer, parameter :: cctki_use_eth2jcn_e = kind(eth2jcn_e)
  COMPLEX*16 eth2jcs_e (X0cmplxcharfuncs_basic_e_south,X1cmplxcharfuncs_basic_e_south,cmplxcharfuncs_basic_e_south_length)
  integer, parameter :: cctki_use_eth2jcs_e = kind(eth2jcs_e)
  COMPLEX*16 jcn_e (X0cmplxcharfuncs_basic_e,X1cmplxcharfuncs_basic_e,cmplxcharfuncs_basic_e_length)
  integer, parameter :: cctki_use_jcn_e = kind(jcn_e)
  REAL*8 jcni (X0cmplxcharfuncs_basic_e_split,X1cmplxcharfuncs_basic_e_split,cmplxcharfuncs_basic_e_split_length)
  integer, parameter :: cctki_use_jcni = kind(jcni)
  REAL*8 jcni_e (X0cmplxcharfuncs_basic_e_split,X1cmplxcharfuncs_basic_e_split,cmplxcharfuncs_basic_e_split_length)
  integer, parameter :: cctki_use_jcni_e = kind(jcni_e)
  REAL*8 jcnr (X0cmplxcharfuncs_basic_e_split,X1cmplxcharfuncs_basic_e_split,cmplxcharfuncs_basic_e_split_length)
  integer, parameter :: cctki_use_jcnr = kind(jcnr)
  REAL*8 jcnr_e (X0cmplxcharfuncs_basic_e_split,X1cmplxcharfuncs_basic_e_split,cmplxcharfuncs_basic_e_split_length)
  integer, parameter :: cctki_use_jcnr_e = kind(jcnr_e)
  COMPLEX*16 jcs_e (X0cmplxcharfuncs_basic_e_south,X1cmplxcharfuncs_basic_e_south,cmplxcharfuncs_basic_e_south_length)
  integer, parameter :: cctki_use_jcs_e = kind(jcs_e)
  REAL*8 mu_e (X0mu_err,X1mu_err,mu_err_length)
  integer, parameter :: cctki_use_mu_e = kind(mu_e)
  REAL*8 muh (X0hmu,X1hmu,hmu_length)
  integer, parameter :: cctki_use_muh = kind(muh)
  COMPLEX*16 nJ_l_e (X0J_l_err,X1J_l_err,J_l_err_length)
  integer, parameter :: cctki_use_nJ_l_e = kind(nJ_l_e)
  COMPLEX*16 nucn_e (X0cmplxcharfuncs_aux_e,X1cmplxcharfuncs_aux_e,cmplxcharfuncs_aux_e_length)
  integer, parameter :: cctki_use_nucn_e = kind(nucn_e)
  COMPLEX*16 nucs_e (X0cmplxcharfuncs_aux_e_south,X1cmplxcharfuncs_aux_e_south,cmplxcharfuncs_aux_e_south_length)
  integer, parameter :: cctki_use_nucs_e = kind(nucs_e)
  COMPLEX*16 num_J_l (X0num_J_l,X1num_J_l,num_J_l_length)
  integer, parameter :: cctki_use_num_J_l = kind(num_J_l)
  COMPLEX*16 qcn_e (X0cmplxcharfuncs_basic_e,X1cmplxcharfuncs_basic_e,cmplxcharfuncs_basic_e_length)
  integer, parameter :: cctki_use_qcn_e = kind(qcn_e)
  COMPLEX*16 qcs_e (X0cmplxcharfuncs_basic_e_south,X1cmplxcharfuncs_basic_e_south,cmplxcharfuncs_basic_e_south_length)
  integer, parameter :: cctki_use_qcs_e = kind(qcs_e)
  REAL*8 uBondi_e (X0uBondi_e,X1uBondi_e,uBondi_e_length)
  integer, parameter :: cctki_use_uBondi_e = kind(uBondi_e)
  COMPLEX*16 ucn_e (X0cmplxcharfuncs_basic_e,X1cmplxcharfuncs_basic_e,cmplxcharfuncs_basic_e_length)
  integer, parameter :: cctki_use_ucn_e = kind(ucn_e)
  COMPLEX*16 ucs_e (X0cmplxcharfuncs_basic_e_south,X1cmplxcharfuncs_basic_e_south,cmplxcharfuncs_basic_e_south_length)
  integer, parameter :: cctki_use_ucs_e = kind(ucs_e)
  REAL*8 wcn_e (X0realcharfuncs_e,X1realcharfuncs_e,realcharfuncs_e_length)
  integer, parameter :: cctki_use_wcn_e = kind(wcn_e)
  REAL*8 wcs_e (X0realcharfuncs_e_south,X1realcharfuncs_e_south,realcharfuncs_e_south_length)
  integer, parameter :: cctki_use_wcs_e = kind(wcs_e)
  INTEGER SHRE_alpha_e_length
  INTEGER SHRE_beta_e_length
  INTEGER SHRE_dalpha_e_length
  INTEGER SHRE_dbeta_e_length
  INTEGER SHRE_dgij_e_length
  INTEGER SHRE_dgit_e_length
  INTEGER SHRE_gij_e_length
  INTEGER SHRE_git_e_length
  INTEGER WT_r0_length
  INTEGER X0SHRE_alpha_e
  INTEGER X0SHRE_beta_e
  INTEGER X0SHRE_dalpha_e
  INTEGER X0SHRE_dbeta_e
  INTEGER X0SHRE_dgij_e
  INTEGER X0SHRE_dgit_e
  INTEGER X0SHRE_gij_e
  INTEGER X0SHRE_git_e
  INTEGER X0WT_r0
  INTEGER X0beta_l
  INTEGER X0beta_wt
  INTEGER X0j_l
  INTEGER X0j_wt
  INTEGER X0q_wt
  INTEGER X0u_l
  INTEGER X0u_wt
  INTEGER X0u_x_wt
  INTEGER X0w_l
  INTEGER X0w_wt
  INTEGER X0x_wt
  INTEGER X1SHRE_alpha_e
  INTEGER X1SHRE_beta_e
  INTEGER X1SHRE_dalpha_e
  INTEGER X1SHRE_dbeta_e
  INTEGER X1SHRE_dgij_e
  INTEGER X1SHRE_dgit_e
  INTEGER X1SHRE_gij_e
  INTEGER X1SHRE_git_e
  INTEGER X1WT_r0
  INTEGER X1beta_l
  INTEGER X1beta_wt
  INTEGER X1j_l
  INTEGER X1j_wt
  INTEGER X1q_wt
  INTEGER X1u_l
  INTEGER X1u_wt
  INTEGER X1u_x_wt
  INTEGER X1w_l
  INTEGER X1w_wt
  INTEGER X1x_wt
  INTEGER beta_l_length
  INTEGER beta_wt_length
  INTEGER j_l_length
  INTEGER j_wt_length
  INTEGER q_wt_length
  INTEGER u_l_length
  INTEGER u_wt_length
  INTEGER u_x_wt_length
  INTEGER w_l_length
  INTEGER w_wt_length
  INTEGER x_wt_length
  REAL*8 SHRE_alpha_e (X0SHRE_alpha_e,X1SHRE_alpha_e,SHRE_alpha_e_length)
  integer, parameter :: cctki_use_SHRE_alpha_e = kind(SHRE_alpha_e)
  REAL*8 SHRE_beta_e (X0SHRE_beta_e,X1SHRE_beta_e,SHRE_beta_e_length)
  integer, parameter :: cctki_use_SHRE_beta_e = kind(SHRE_beta_e)
  REAL*8 SHRE_dpalpha_e (X0SHRE_dalpha_e,X1SHRE_dalpha_e,SHRE_dalpha_e_length)
  integer, parameter :: cctki_use_SHRE_dpalpha_e = kind(SHRE_dpalpha_e)
  REAL*8 SHRE_dpbeta_e (X0SHRE_dbeta_e,X1SHRE_dbeta_e,SHRE_dbeta_e_length)
  integer, parameter :: cctki_use_SHRE_dpbeta_e = kind(SHRE_dpbeta_e)
  REAL*8 SHRE_dpgij_e (X0SHRE_dgij_e,X1SHRE_dgij_e,SHRE_dgij_e_length)
  integer, parameter :: cctki_use_SHRE_dpgij_e = kind(SHRE_dpgij_e)
  REAL*8 SHRE_dpgit_e (X0SHRE_dgit_e,X1SHRE_dgit_e,SHRE_dgit_e_length)
  integer, parameter :: cctki_use_SHRE_dpgit_e = kind(SHRE_dpgit_e)
  REAL*8 SHRE_dqalpha_e (X0SHRE_dalpha_e,X1SHRE_dalpha_e,SHRE_dalpha_e_length)
  integer, parameter :: cctki_use_SHRE_dqalpha_e = kind(SHRE_dqalpha_e)
  REAL*8 SHRE_dqbeta_e (X0SHRE_dbeta_e,X1SHRE_dbeta_e,SHRE_dbeta_e_length)
  integer, parameter :: cctki_use_SHRE_dqbeta_e = kind(SHRE_dqbeta_e)
  REAL*8 SHRE_dqgij_e (X0SHRE_dgij_e,X1SHRE_dgij_e,SHRE_dgij_e_length)
  integer, parameter :: cctki_use_SHRE_dqgij_e = kind(SHRE_dqgij_e)
  REAL*8 SHRE_dqgit_e (X0SHRE_dgit_e,X1SHRE_dgit_e,SHRE_dgit_e_length)
  integer, parameter :: cctki_use_SHRE_dqgit_e = kind(SHRE_dqgit_e)
  REAL*8 SHRE_dralpha_e (X0SHRE_dalpha_e,X1SHRE_dalpha_e,SHRE_dalpha_e_length)
  integer, parameter :: cctki_use_SHRE_dralpha_e = kind(SHRE_dralpha_e)
  REAL*8 SHRE_drbeta_e (X0SHRE_dbeta_e,X1SHRE_dbeta_e,SHRE_dbeta_e_length)
  integer, parameter :: cctki_use_SHRE_drbeta_e = kind(SHRE_drbeta_e)
  REAL*8 SHRE_drgij_e (X0SHRE_dgij_e,X1SHRE_dgij_e,SHRE_dgij_e_length)
  integer, parameter :: cctki_use_SHRE_drgij_e = kind(SHRE_drgij_e)
  REAL*8 SHRE_drgit_e (X0SHRE_dgit_e,X1SHRE_dgit_e,SHRE_dgit_e_length)
  integer, parameter :: cctki_use_SHRE_drgit_e = kind(SHRE_drgit_e)
  REAL*8 SHRE_dtalpha_e (X0SHRE_dalpha_e,X1SHRE_dalpha_e,SHRE_dalpha_e_length)
  integer, parameter :: cctki_use_SHRE_dtalpha_e = kind(SHRE_dtalpha_e)
  REAL*8 SHRE_dtbeta_e (X0SHRE_dbeta_e,X1SHRE_dbeta_e,SHRE_dbeta_e_length)
  integer, parameter :: cctki_use_SHRE_dtbeta_e = kind(SHRE_dtbeta_e)
  REAL*8 SHRE_dtgij_e (X0SHRE_dgij_e,X1SHRE_dgij_e,SHRE_dgij_e_length)
  integer, parameter :: cctki_use_SHRE_dtgij_e = kind(SHRE_dtgij_e)
  REAL*8 SHRE_dtgit_e (X0SHRE_dgit_e,X1SHRE_dgit_e,SHRE_dgit_e_length)
  integer, parameter :: cctki_use_SHRE_dtgit_e = kind(SHRE_dtgit_e)
  REAL*8 SHRE_gij_e (X0SHRE_gij_e,X1SHRE_gij_e,SHRE_gij_e_length)
  integer, parameter :: cctki_use_SHRE_gij_e = kind(SHRE_gij_e)
  REAL*8 SHRE_git_e (X0SHRE_git_e,X1SHRE_git_e,SHRE_git_e_length)
  integer, parameter :: cctki_use_SHRE_git_e = kind(SHRE_git_e)
  REAL*8 WT_r0 (X0WT_r0,X1WT_r0,WT_r0_length)
  integer, parameter :: cctki_use_WT_r0 = kind(WT_r0)
  REAL*8 beta_l (X0beta_l,X1beta_l,beta_l_length)
  integer, parameter :: cctki_use_beta_l = kind(beta_l)
  REAL*8 beta_wt (X0beta_wt,X1beta_wt,beta_wt_length)
  integer, parameter :: cctki_use_beta_wt = kind(beta_wt)
  REAL*8 beta_wt_p (X0beta_wt,X1beta_wt,beta_wt_length)
  integer, parameter :: cctki_use_beta_wt_p = kind(beta_wt_p)
  COMPLEX*16 j_l (X0j_l,X1j_l,j_l_length)
  integer, parameter :: cctki_use_j_l = kind(j_l)
  COMPLEX*16 j_wt (X0j_wt,X1j_wt,j_wt_length)
  integer, parameter :: cctki_use_j_wt = kind(j_wt)
  COMPLEX*16 j_wt_p (X0j_wt,X1j_wt,j_wt_length)
  integer, parameter :: cctki_use_j_wt_p = kind(j_wt_p)
  COMPLEX*16 q_wt (X0q_wt,X1q_wt,q_wt_length)
  integer, parameter :: cctki_use_q_wt = kind(q_wt)
  COMPLEX*16 q_wt_p (X0q_wt,X1q_wt,q_wt_length)
  integer, parameter :: cctki_use_q_wt_p = kind(q_wt_p)
  COMPLEX*16 u_l (X0u_l,X1u_l,u_l_length)
  integer, parameter :: cctki_use_u_l = kind(u_l)
  COMPLEX*16 u_wt (X0u_wt,X1u_wt,u_wt_length)
  integer, parameter :: cctki_use_u_wt = kind(u_wt)
  COMPLEX*16 u_wt_p (X0u_wt,X1u_wt,u_wt_length)
  integer, parameter :: cctki_use_u_wt_p = kind(u_wt_p)
  COMPLEX*16 u_x_wt (X0u_x_wt,X1u_x_wt,u_x_wt_length)
  integer, parameter :: cctki_use_u_x_wt = kind(u_x_wt)
  REAL*8 w_l (X0w_l,X1w_l,w_l_length)
  integer, parameter :: cctki_use_w_l = kind(w_l)
  REAL*8 w_wt (X0w_wt,X1w_wt,w_wt_length)
  integer, parameter :: cctki_use_w_wt = kind(w_wt)
  REAL*8 w_wt_p (X0w_wt,X1w_wt,w_wt_length)
  integer, parameter :: cctki_use_w_wt_p = kind(w_wt_p)
  REAL*8 x_wt (X0x_wt,X1x_wt,x_wt_length)
  integer, parameter :: cctki_use_x_wt = kind(x_wt)
  REAL*8 x_wt_p (X0x_wt,X1x_wt,x_wt_length)
  integer, parameter :: cctki_use_x_wt_p = kind(x_wt_p)
  INTEGER JJ_l_length
  INTEGER NewsB_length
  INTEGER NewsB_past_length
  INTEGER NewsB_uBondi_length
  INTEGER News_length
  INTEGER News_past_length
  INTEGER News_uBondi_length
  INTEGER Null_AuxConstr_length
  INTEGER Null_AuxConstr_south_length
  INTEGER Null_R00_length
  INTEGER Null_R00_south_length
  INTEGER Null_R01_length
  INTEGER Null_R01_south_length
  INTEGER Null_R0A_length
  INTEGER Null_R0A_south_length
  INTEGER Null_R0A_split_length
  INTEGER Psi4_length
  INTEGER Psi4_past_length
  INTEGER Psi4_uBondi_length
  INTEGER X0EG_mask
  INTEGER X0EQ_mask
  INTEGER X0EV_mask
  INTEGER X0JJ_l
  INTEGER X0News
  INTEGER X0NewsB
  INTEGER X0NewsB_past
  INTEGER X0NewsB_uBondi
  INTEGER X0News_past
  INTEGER X0News_uBondi
  INTEGER X0NullGrParArrI
  INTEGER X0NullGrParArrR
  INTEGER X0Null_AuxConstr
  INTEGER X0Null_AuxConstr_south
  INTEGER X0Null_R00
  INTEGER X0Null_R00_south
  INTEGER X0Null_R01
  INTEGER X0Null_R01_south
  INTEGER X0Null_R0A
  INTEGER X0Null_R0A_south
  INTEGER X0Null_R0A_split
  INTEGER X0Psi4
  INTEGER X0Psi4_past
  INTEGER X0Psi4_uBondi
  INTEGER X0RadCrd
  INTEGER X0StCmCrd
  INTEGER X0StCrd
  INTEGER X0cmplxcharfuncs_aux
  INTEGER X0cmplxcharfuncs_basic
  INTEGER X0guard_mask
  INTEGER X0linStrain
  INTEGER X0linStrain_past
  INTEGER X0linStrain_uBondi
  INTEGER X0null_mask
  INTEGER X0omega
  INTEGER X0realcharfuncs
  INTEGER X0tmp_cgf
  INTEGER X0tmp_cgf3
  INTEGER X0tmp_rgf
  INTEGER X0uBondi
  INTEGER X0uBondi_past
  INTEGER X1EG_mask
  INTEGER X1EQ_mask
  INTEGER X1EV_mask
  INTEGER X1JJ_l
  INTEGER X1News
  INTEGER X1NewsB
  INTEGER X1NewsB_past
  INTEGER X1NewsB_uBondi
  INTEGER X1News_past
  INTEGER X1News_uBondi
  INTEGER X1Null_AuxConstr
  INTEGER X1Null_AuxConstr_south
  INTEGER X1Null_R00
  INTEGER X1Null_R00_south
  INTEGER X1Null_R01
  INTEGER X1Null_R01_south
  INTEGER X1Null_R0A
  INTEGER X1Null_R0A_south
  INTEGER X1Null_R0A_split
  INTEGER X1Psi4
  INTEGER X1Psi4_past
  INTEGER X1Psi4_uBondi
  INTEGER X1StCmCrd
  INTEGER X1StCrd
  INTEGER X1cmplxcharfuncs_aux
  INTEGER X1cmplxcharfuncs_basic
  INTEGER X1guard_mask
  INTEGER X1linStrain
  INTEGER X1linStrain_past
  INTEGER X1linStrain_uBondi
  INTEGER X1null_mask
  INTEGER X1omega
  INTEGER X1realcharfuncs
  INTEGER X1tmp_cgf
  INTEGER X1tmp_cgf3
  INTEGER X1tmp_rgf
  INTEGER X1uBondi
  INTEGER X1uBondi_past
  INTEGER cmplxcharfuncs_aux_length
  INTEGER cmplxcharfuncs_basic_length
  INTEGER linStrain_length
  INTEGER linStrain_past_length
  INTEGER linStrain_uBondi_length
  INTEGER omega_length
  INTEGER realcharfuncs_length
  INTEGER uBondi_length
  INTEGER uBondi_past_length
  INTEGER*4 EG_mask (X0EG_mask,X1EG_mask)
  integer, parameter :: cctki_use_EG_mask = kind(EG_mask)
  INTEGER*4 EQ_mask (X0EQ_mask,X1EQ_mask)
  integer, parameter :: cctki_use_EQ_mask = kind(EQ_mask)
  INTEGER*4 EV_mask (X0EV_mask,X1EV_mask)
  integer, parameter :: cctki_use_EV_mask = kind(EV_mask)
  COMPLEX*16 Jn_l (X0JJ_l,X1JJ_l,JJ_l_length)
  integer, parameter :: cctki_use_Jn_l = kind(Jn_l)
  COMPLEX*16 Jo_l (X0JJ_l,X1JJ_l,JJ_l_length)
  integer, parameter :: cctki_use_Jo_l = kind(Jo_l)
  COMPLEX*16 News (X0News,X1News,News_length)
  integer, parameter :: cctki_use_News = kind(News)
  COMPLEX*16 NewsB (X0NewsB,X1NewsB,NewsB_length)
  integer, parameter :: cctki_use_NewsB = kind(NewsB)
  COMPLEX*16 NewsB_past (X0NewsB_past,X1NewsB_past,NewsB_past_length)
  integer, parameter :: cctki_use_NewsB_past = kind(NewsB_past)
  COMPLEX*16 NewsB_uBondi (X0NewsB_uBondi,X1NewsB_uBondi,NewsB_uBondi_length)
  integer, parameter :: cctki_use_NewsB_uBondi = kind(NewsB_uBondi)
  COMPLEX*16 News_past (X0News_past,X1News_past,News_past_length)
  integer, parameter :: cctki_use_News_past = kind(News_past)
  COMPLEX*16 News_uBondi (X0News_uBondi,X1News_uBondi,News_uBondi_length)
  integer, parameter :: cctki_use_News_uBondi = kind(News_uBondi)
  COMPLEX*16 Null_AuxConstr_cbcn (X0Null_AuxConstr,X1Null_AuxConstr,Null_AuxConstr_length)
  integer, parameter :: cctki_use_Null_AuxConstr_cbcn = kind(Null_AuxConstr_cbcn)
  COMPLEX*16 Null_AuxConstr_cbcs (X0Null_AuxConstr_south,X1Null_AuxConstr_south,Null_AuxConstr_south_length)
  integer, parameter :: cctki_use_Null_AuxConstr_cbcs = kind(Null_AuxConstr_cbcs)
  COMPLEX*16 Null_AuxConstr_ckcn (X0Null_AuxConstr,X1Null_AuxConstr,Null_AuxConstr_length)
  integer, parameter :: cctki_use_Null_AuxConstr_ckcn = kind(Null_AuxConstr_ckcn)
  COMPLEX*16 Null_AuxConstr_ckcs (X0Null_AuxConstr_south,X1Null_AuxConstr_south,Null_AuxConstr_south_length)
  integer, parameter :: cctki_use_Null_AuxConstr_ckcs = kind(Null_AuxConstr_ckcs)
  COMPLEX*16 Null_AuxConstr_nucn (X0Null_AuxConstr,X1Null_AuxConstr,Null_AuxConstr_length)
  integer, parameter :: cctki_use_Null_AuxConstr_nucn = kind(Null_AuxConstr_nucn)
  COMPLEX*16 Null_AuxConstr_nucs (X0Null_AuxConstr_south,X1Null_AuxConstr_south,Null_AuxConstr_south_length)
  integer, parameter :: cctki_use_Null_AuxConstr_nucs = kind(Null_AuxConstr_nucs)
  REAL*8 Null_R00 (X0Null_R00,X1Null_R00,Null_R00_length)
  integer, parameter :: cctki_use_Null_R00 = kind(Null_R00)
  REAL*8 Null_R00_south (X0Null_R00_south,X1Null_R00_south,Null_R00_south_length)
  integer, parameter :: cctki_use_Null_R00_south = kind(Null_R00_south)
  REAL*8 Null_R01 (X0Null_R01,X1Null_R01,Null_R01_length)
  integer, parameter :: cctki_use_Null_R01 = kind(Null_R01)
  REAL*8 Null_R01_south (X0Null_R01_south,X1Null_R01_south,Null_R01_south_length)
  integer, parameter :: cctki_use_Null_R01_south = kind(Null_R01_south)
  COMPLEX*16 Null_R0A (X0Null_R0A,X1Null_R0A,Null_R0A_length)
  integer, parameter :: cctki_use_Null_R0A = kind(Null_R0A)
  REAL*8 Null_R0A_i (X0Null_R0A_split,X1Null_R0A_split,Null_R0A_split_length)
  integer, parameter :: cctki_use_Null_R0A_i = kind(Null_R0A_i)
  REAL*8 Null_R0A_r (X0Null_R0A_split,X1Null_R0A_split,Null_R0A_split_length)
  integer, parameter :: cctki_use_Null_R0A_r = kind(Null_R0A_r)
  COMPLEX*16 Null_R0A_south (X0Null_R0A_south,X1Null_R0A_south,Null_R0A_south_length)
  integer, parameter :: cctki_use_Null_R0A_south = kind(Null_R0A_south)
  COMPLEX*16 Psi4 (X0Psi4,X1Psi4,Psi4_length)
  integer, parameter :: cctki_use_Psi4 = kind(Psi4)
  COMPLEX*16 Psi4_past (X0Psi4_past,X1Psi4_past,Psi4_past_length)
  integer, parameter :: cctki_use_Psi4_past = kind(Psi4_past)
  COMPLEX*16 Psi4_uBondi (X0Psi4_uBondi,X1Psi4_uBondi,Psi4_uBondi_length)
  integer, parameter :: cctki_use_Psi4_uBondi = kind(Psi4_uBondi)
  REAL*8 bcn (X0realcharfuncs,X1realcharfuncs,realcharfuncs_length)
  integer, parameter :: cctki_use_bcn = kind(bcn)
  REAL*8 bcn_p (X0realcharfuncs,X1realcharfuncs,realcharfuncs_length)
  integer, parameter :: cctki_use_bcn_p = kind(bcn_p)
  REAL*8 bcs (X0realcharfuncs,X1realcharfuncs,realcharfuncs_length)
  integer, parameter :: cctki_use_bcs = kind(bcs)
  REAL*8 bcs_p (X0realcharfuncs,X1realcharfuncs,realcharfuncs_length)
  integer, parameter :: cctki_use_bcs_p = kind(bcs_p)
  INTEGER*4 boundary_maskn (X0null_mask,X1null_mask)
  integer, parameter :: cctki_use_boundary_maskn = kind(boundary_maskn)
  INTEGER*4 boundary_masks (X0null_mask,X1null_mask)
  integer, parameter :: cctki_use_boundary_masks = kind(boundary_masks)
  COMPLEX*16 cbcn (X0cmplxcharfuncs_aux,X1cmplxcharfuncs_aux,cmplxcharfuncs_aux_length)
  integer, parameter :: cctki_use_cbcn = kind(cbcn)
  COMPLEX*16 cbcn_p (X0cmplxcharfuncs_aux,X1cmplxcharfuncs_aux,cmplxcharfuncs_aux_length)
  integer, parameter :: cctki_use_cbcn_p = kind(cbcn_p)
  COMPLEX*16 cbcs (X0cmplxcharfuncs_aux,X1cmplxcharfuncs_aux,cmplxcharfuncs_aux_length)
  integer, parameter :: cctki_use_cbcs = kind(cbcs)
  COMPLEX*16 cbcs_p (X0cmplxcharfuncs_aux,X1cmplxcharfuncs_aux,cmplxcharfuncs_aux_length)
  integer, parameter :: cctki_use_cbcs_p = kind(cbcs_p)
  COMPLEX*16 ckcn (X0cmplxcharfuncs_aux,X1cmplxcharfuncs_aux,cmplxcharfuncs_aux_length)
  integer, parameter :: cctki_use_ckcn = kind(ckcn)
  COMPLEX*16 ckcn_p (X0cmplxcharfuncs_aux,X1cmplxcharfuncs_aux,cmplxcharfuncs_aux_length)
  integer, parameter :: cctki_use_ckcn_p = kind(ckcn_p)
  COMPLEX*16 ckcs (X0cmplxcharfuncs_aux,X1cmplxcharfuncs_aux,cmplxcharfuncs_aux_length)
  integer, parameter :: cctki_use_ckcs = kind(ckcs)
  COMPLEX*16 ckcs_p (X0cmplxcharfuncs_aux,X1cmplxcharfuncs_aux,cmplxcharfuncs_aux_length)
  integer, parameter :: cctki_use_ckcs_p = kind(ckcs_p)
  REAL*8 constant_uBondi
  integer, parameter :: cctki_use_constant_uBondi = kind(constant_uBondi)
  REAL*8 courant_min_time
  integer, parameter :: cctki_use_courant_min_time = kind(courant_min_time)
  REAL*8 courant_wave_speed
  integer, parameter :: cctki_use_courant_wave_speed = kind(courant_wave_speed)
  COMPLEX*16 dxjcn (X0cmplxcharfuncs_basic,X1cmplxcharfuncs_basic,cmplxcharfuncs_basic_length)
  integer, parameter :: cctki_use_dxjcn = kind(dxjcn)
  COMPLEX*16 dxjcn_p (X0cmplxcharfuncs_basic,X1cmplxcharfuncs_basic,cmplxcharfuncs_basic_length)
  integer, parameter :: cctki_use_dxjcn_p = kind(dxjcn_p)
  COMPLEX*16 dxjcs (X0cmplxcharfuncs_basic,X1cmplxcharfuncs_basic,cmplxcharfuncs_basic_length)
  integer, parameter :: cctki_use_dxjcs = kind(dxjcs)
  COMPLEX*16 dxjcs_p (X0cmplxcharfuncs_basic,X1cmplxcharfuncs_basic,cmplxcharfuncs_basic_length)
  integer, parameter :: cctki_use_dxjcs_p = kind(dxjcs_p)
  COMPLEX*16 eth2jcn (X0cmplxcharfuncs_basic,X1cmplxcharfuncs_basic,cmplxcharfuncs_basic_length)
  integer, parameter :: cctki_use_eth2jcn = kind(eth2jcn)
  COMPLEX*16 eth2jcn_p (X0cmplxcharfuncs_basic,X1cmplxcharfuncs_basic,cmplxcharfuncs_basic_length)
  integer, parameter :: cctki_use_eth2jcn_p = kind(eth2jcn_p)
  COMPLEX*16 eth2jcs (X0cmplxcharfuncs_basic,X1cmplxcharfuncs_basic,cmplxcharfuncs_basic_length)
  integer, parameter :: cctki_use_eth2jcs = kind(eth2jcs)
  COMPLEX*16 eth2jcs_p (X0cmplxcharfuncs_basic,X1cmplxcharfuncs_basic,cmplxcharfuncs_basic_length)
  integer, parameter :: cctki_use_eth2jcs_p = kind(eth2jcs_p)
  INTEGER*4 evolution_maskn (X0null_mask,X1null_mask)
  integer, parameter :: cctki_use_evolution_maskn = kind(evolution_maskn)
  INTEGER*4 evolution_masks (X0null_mask,X1null_mask)
  integer, parameter :: cctki_use_evolution_masks = kind(evolution_masks)
  REAL*8 evolution_radius
  integer, parameter :: cctki_use_evolution_radius = kind(evolution_radius)
  INTEGER*4 guard_mask (X0guard_mask,X1guard_mask)
  integer, parameter :: cctki_use_guard_mask = kind(guard_mask)
  COMPLEX*16 jcn (X0cmplxcharfuncs_basic,X1cmplxcharfuncs_basic,cmplxcharfuncs_basic_length)
  integer, parameter :: cctki_use_jcn = kind(jcn)
  COMPLEX*16 jcn_p (X0cmplxcharfuncs_basic,X1cmplxcharfuncs_basic,cmplxcharfuncs_basic_length)
  integer, parameter :: cctki_use_jcn_p = kind(jcn_p)
  COMPLEX*16 jcs (X0cmplxcharfuncs_basic,X1cmplxcharfuncs_basic,cmplxcharfuncs_basic_length)
  integer, parameter :: cctki_use_jcs = kind(jcs)
  COMPLEX*16 jcs_p (X0cmplxcharfuncs_basic,X1cmplxcharfuncs_basic,cmplxcharfuncs_basic_length)
  integer, parameter :: cctki_use_jcs_p = kind(jcs_p)
  COMPLEX*16 linStrain (X0linStrain,X1linStrain,linStrain_length)
  integer, parameter :: cctki_use_linStrain = kind(linStrain)
  COMPLEX*16 linStrain_past (X0linStrain_past,X1linStrain_past,linStrain_past_length)
  integer, parameter :: cctki_use_linStrain_past = kind(linStrain_past)
  COMPLEX*16 linStrain_uBondi (X0linStrain_uBondi,X1linStrain_uBondi,linStrain_uBondi_length)
  integer, parameter :: cctki_use_linStrain_uBondi = kind(linStrain_uBondi)
  COMPLEX*16 nucn (X0cmplxcharfuncs_aux,X1cmplxcharfuncs_aux,cmplxcharfuncs_aux_length)
  integer, parameter :: cctki_use_nucn = kind(nucn)
  COMPLEX*16 nucn_p (X0cmplxcharfuncs_aux,X1cmplxcharfuncs_aux,cmplxcharfuncs_aux_length)
  integer, parameter :: cctki_use_nucn_p = kind(nucn_p)
  COMPLEX*16 nucs (X0cmplxcharfuncs_aux,X1cmplxcharfuncs_aux,cmplxcharfuncs_aux_length)
  integer, parameter :: cctki_use_nucs = kind(nucs)
  COMPLEX*16 nucs_p (X0cmplxcharfuncs_aux,X1cmplxcharfuncs_aux,cmplxcharfuncs_aux_length)
  integer, parameter :: cctki_use_nucs_p = kind(nucs_p)
  REAL*8 null_delta (X0NullGrParArrR)
  integer, parameter :: cctki_use_null_delta = kind(null_delta)
  REAL*8 null_dx
  integer, parameter :: cctki_use_null_dx = kind(null_dx)
  INTEGER*4 null_gsh (X0NullGrParArrI)
  integer, parameter :: cctki_use_null_gsh = kind(null_gsh)
  INTEGER*4 null_lbnd (X0NullGrParArrI)
  integer, parameter :: cctki_use_null_lbnd = kind(null_lbnd)
  INTEGER*4 null_lsh (X0NullGrParArrI)
  integer, parameter :: cctki_use_null_lsh = kind(null_lsh)
  REAL*8 null_rb (X0RadCrd)
  integer, parameter :: cctki_use_null_rb = kind(null_rb)
  REAL*8 null_rbh (X0RadCrd)
  integer, parameter :: cctki_use_null_rbh = kind(null_rbh)
  INTEGER*4 null_ubnd (X0NullGrParArrI)
  integer, parameter :: cctki_use_null_ubnd = kind(null_ubnd)
  REAL*8 null_xb (X0RadCrd)
  integer, parameter :: cctki_use_null_xb = kind(null_xb)
  REAL*8 null_xbh (X0RadCrd)
  integer, parameter :: cctki_use_null_xbh = kind(null_xbh)
  REAL*8 omegan (X0omega,X1omega,omega_length)
  integer, parameter :: cctki_use_omegan = kind(omegan)
  REAL*8 omegao (X0omega,X1omega,omega_length)
  integer, parameter :: cctki_use_omegao = kind(omegao)
  COMPLEX*16 qcn (X0cmplxcharfuncs_basic,X1cmplxcharfuncs_basic,cmplxcharfuncs_basic_length)
  integer, parameter :: cctki_use_qcn = kind(qcn)
  COMPLEX*16 qcn_p (X0cmplxcharfuncs_basic,X1cmplxcharfuncs_basic,cmplxcharfuncs_basic_length)
  integer, parameter :: cctki_use_qcn_p = kind(qcn_p)
  COMPLEX*16 qcs (X0cmplxcharfuncs_basic,X1cmplxcharfuncs_basic,cmplxcharfuncs_basic_length)
  integer, parameter :: cctki_use_qcs = kind(qcs)
  COMPLEX*16 qcs_p (X0cmplxcharfuncs_basic,X1cmplxcharfuncs_basic,cmplxcharfuncs_basic_length)
  integer, parameter :: cctki_use_qcs_p = kind(qcs_p)
  REAL*8 qsize
  integer, parameter :: cctki_use_qsize = kind(qsize)
  REAL*8 stereo_p (X0StCrd,X1StCrd)
  integer, parameter :: cctki_use_stereo_p = kind(stereo_p)
  REAL*8 stereo_pp (X0StCrd,X1StCrd)
  integer, parameter :: cctki_use_stereo_pp = kind(stereo_pp)
  REAL*8 stereo_q (X0StCrd,X1StCrd)
  integer, parameter :: cctki_use_stereo_q = kind(stereo_q)
  REAL*8 time_of_news
  integer, parameter :: cctki_use_time_of_news = kind(time_of_news)
  COMPLEX*16 tmp_cgfn (X0tmp_cgf,X1tmp_cgf)
  integer, parameter :: cctki_use_tmp_cgfn = kind(tmp_cgfn)
  COMPLEX*16 tmp_cgfn1 (X0tmp_cgf3,X1tmp_cgf3)
  integer, parameter :: cctki_use_tmp_cgfn1 = kind(tmp_cgfn1)
  COMPLEX*16 tmp_cgfn2 (X0tmp_cgf3,X1tmp_cgf3)
  integer, parameter :: cctki_use_tmp_cgfn2 = kind(tmp_cgfn2)
  COMPLEX*16 tmp_cgfn3 (X0tmp_cgf3,X1tmp_cgf3)
  integer, parameter :: cctki_use_tmp_cgfn3 = kind(tmp_cgfn3)
  COMPLEX*16 tmp_cgfs (X0tmp_cgf,X1tmp_cgf)
  integer, parameter :: cctki_use_tmp_cgfs = kind(tmp_cgfs)
  COMPLEX*16 tmp_cgfs1 (X0tmp_cgf3,X1tmp_cgf3)
  integer, parameter :: cctki_use_tmp_cgfs1 = kind(tmp_cgfs1)
  COMPLEX*16 tmp_cgfs2 (X0tmp_cgf3,X1tmp_cgf3)
  integer, parameter :: cctki_use_tmp_cgfs2 = kind(tmp_cgfs2)
  COMPLEX*16 tmp_cgfs3 (X0tmp_cgf3,X1tmp_cgf3)
  integer, parameter :: cctki_use_tmp_cgfs3 = kind(tmp_cgfs3)
  REAL*8 tmp_rgfn (X0tmp_rgf,X1tmp_rgf)
  integer, parameter :: cctki_use_tmp_rgfn = kind(tmp_rgfn)
  REAL*8 tmp_rgfs (X0tmp_rgf,X1tmp_rgf)
  integer, parameter :: cctki_use_tmp_rgfs = kind(tmp_rgfs)
  REAL*8 uBondi (X0uBondi,X1uBondi,uBondi_length)
  integer, parameter :: cctki_use_uBondi = kind(uBondi)
  REAL*8 uBondi_past (X0uBondi_past,X1uBondi_past,uBondi_past_length)
  integer, parameter :: cctki_use_uBondi_past = kind(uBondi_past)
  COMPLEX*16 ucn (X0cmplxcharfuncs_basic,X1cmplxcharfuncs_basic,cmplxcharfuncs_basic_length)
  integer, parameter :: cctki_use_ucn = kind(ucn)
  COMPLEX*16 ucn_p (X0cmplxcharfuncs_basic,X1cmplxcharfuncs_basic,cmplxcharfuncs_basic_length)
  integer, parameter :: cctki_use_ucn_p = kind(ucn_p)
  COMPLEX*16 ucs (X0cmplxcharfuncs_basic,X1cmplxcharfuncs_basic,cmplxcharfuncs_basic_length)
  integer, parameter :: cctki_use_ucs = kind(ucs)
  COMPLEX*16 ucs_p (X0cmplxcharfuncs_basic,X1cmplxcharfuncs_basic,cmplxcharfuncs_basic_length)
  integer, parameter :: cctki_use_ucs_p = kind(ucs_p)
  REAL*8 wcn (X0realcharfuncs,X1realcharfuncs,realcharfuncs_length)
  integer, parameter :: cctki_use_wcn = kind(wcn)
  REAL*8 wcn_p (X0realcharfuncs,X1realcharfuncs,realcharfuncs_length)
  integer, parameter :: cctki_use_wcn_p = kind(wcn_p)
  REAL*8 wcs (X0realcharfuncs,X1realcharfuncs,realcharfuncs_length)
  integer, parameter :: cctki_use_wcs = kind(wcs)
  REAL*8 wcs_p (X0realcharfuncs,X1realcharfuncs,realcharfuncs_length)
  integer, parameter :: cctki_use_wcs_p = kind(wcs_p)
  COMPLEX*16 zeta (X0StCmCrd,X1StCmCrd)
  integer, parameter :: cctki_use_zeta = kind(zeta)
    INTEGER*4 NullExact_MaxEvolvedArraySize
  integer, parameter :: cctki_use_NullExact_MaxEvolvedArraySize = kind(NullExact_MaxEvolvedArraySize)
  INTEGER*4 NullExact_NumArrayEvolvedVars
  integer, parameter :: cctki_use_NullExact_NumArrayEvolvedVars = kind(NullExact_NumArrayEvolvedVars)
  INTEGER*4 l_in_Ylm
  integer, parameter :: cctki_use_l_in_Ylm = kind(l_in_Ylm)
  INTEGER*4 m_in_Ylm
  integer, parameter :: cctki_use_m_in_Ylm = kind(m_in_Ylm)
  COMMON /NullExactrest/NullExact_MaxEvolvedArraySize, NullExact_NumArrayEvolvedVars, l_in_Ylm, m_in_Ylm
  REAL*8 A_r0
  integer, parameter :: cctki_use_A_r0 = kind(A_r0)
  REAL*8 Constant_C1i
  integer, parameter :: cctki_use_Constant_C1i = kind(Constant_C1i)
  REAL*8 Constant_C1r
  integer, parameter :: cctki_use_Constant_C1r = kind(Constant_C1r)
  REAL*8 Constant_C2i
  integer, parameter :: cctki_use_Constant_C2i = kind(Constant_C2i)
  REAL*8 Constant_C2r
  integer, parameter :: cctki_use_Constant_C2r = kind(Constant_C2r)
  REAL*8 F_r0
  integer, parameter :: cctki_use_F_r0 = kind(F_r0)
  REAL*8 amplitude
  integer, parameter :: cctki_use_amplitude = kind(amplitude)
  REAL*8 beta0i
  integer, parameter :: cctki_use_beta0i = kind(beta0i)
  REAL*8 beta0r
  integer, parameter :: cctki_use_beta0r = kind(beta0r)
  REAL*8 omm
  integer, parameter :: cctki_use_omm = kind(omm)
  integer*8 error_mask_type
  integer, parameter :: cctki_use_error_mask_type = kind(error_mask_type)
  INTEGER*4 analytic_fields
  integer, parameter :: cctki_use_analytic_fields = kind(analytic_fields)
  INTEGER*4 testbed_ID
  integer, parameter :: cctki_use_testbed_ID = kind(testbed_ID)
  INTEGER*4 verbose
  integer, parameter :: cctki_use_verbose = kind(verbose)
  COMMON /NullExactpriv/A_r0, Constant_C1i, Constant_C1r, Constant_C2i, Constant_C2r, F_r0, amplitude, beta0i, beta0r, omm, error_m&
  &ask_type, analytic_fields, testbed_ID, verbose
  INTEGER*4 MoL_Max_Evolved_Array_Size
  integer, parameter :: cctki_use_MoL_Max_Evolved_Array_Size = kind(MoL_Max_Evolved_Array_Size)
  INTEGER*4 CCTKH0
  integer, parameter :: cctki_use_CCTKH0 = kind(CCTKH0)
  INTEGER*4 MoL_Num_ArrayEvolved_Vars
  integer, parameter :: cctki_use_MoL_Num_ArrayEvolved_Vars = kind(MoL_Num_ArrayEvolved_Vars)
  INTEGER*4 CCTKH1
  integer, parameter :: cctki_use_CCTKH1 = kind(CCTKH1)
  INTEGER*4 CCTKH2
  integer, parameter :: cctki_use_CCTKH2 = kind(CCTKH2)
  INTEGER*4 CCTKH3
  integer, parameter :: cctki_use_CCTKH3 = kind(CCTKH3)
  INTEGER*4 CCTKH4
  integer, parameter :: cctki_use_CCTKH4 = kind(CCTKH4)
  INTEGER*4 CCTKH5
  integer, parameter :: cctki_use_CCTKH5 = kind(CCTKH5)
  INTEGER*4 CCTKH6
  integer, parameter :: cctki_use_CCTKH6 = kind(CCTKH6)
  COMMON /METHODOFLINESrest/MoL_Max_Evolved_Array_Size, CCTKH0, MoL_Num_ArrayEvolved_Vars, CCTKH1, CCTKH2, CCTKH3, CCTKH4, CCTKH5, &
  &CCTKH6
  REAL*8 CCTKH16
  integer, parameter :: cctki_use_CCTKH16 = kind(CCTKH16)
  integer*8 boundary_data
  integer, parameter :: cctki_use_boundary_data = kind(boundary_data)
  integer*8 initial_J_data
  integer, parameter :: cctki_use_initial_J_data = kind(initial_J_data)
  INTEGER*4 CCTKH7
  integer, parameter :: cctki_use_CCTKH7 = kind(CCTKH7)
  INTEGER*4 CCTKH8
  integer, parameter :: cctki_use_CCTKH8 = kind(CCTKH8)
  INTEGER*4 CCTKH9
  integer, parameter :: cctki_use_CCTKH9 = kind(CCTKH9)
  INTEGER*4 CCTKH10
  integer, parameter :: cctki_use_CCTKH10 = kind(CCTKH10)
  INTEGER*4 CCTKH11
  integer, parameter :: cctki_use_CCTKH11 = kind(CCTKH11)
  INTEGER*4 CCTKH12
  integer, parameter :: cctki_use_CCTKH12 = kind(CCTKH12)
  INTEGER*4 CCTKH13
  integer, parameter :: cctki_use_CCTKH13 = kind(CCTKH13)
  INTEGER*4 CCTKH14
  integer, parameter :: cctki_use_CCTKH14 = kind(CCTKH14)
  INTEGER*4 CCTKH15
  integer, parameter :: cctki_use_CCTKH15 = kind(CCTKH15)
  INTEGER*4 CCTKH17
  integer, parameter :: cctki_use_CCTKH17 = kind(CCTKH17)
  INTEGER*4 first_order_scheme
  integer, parameter :: cctki_use_first_order_scheme = kind(first_order_scheme)
  INTEGER*4 CCTKH18
  integer, parameter :: cctki_use_CCTKH18 = kind(CCTKH18)
  COMMON /NULLEVOLVErest/CCTKH16, boundary_data, initial_J_data, CCTKH7, CCTKH8, CCTKH9, CCTKH10, CCTKH11, CCTKH12, CCTKH13, CCTKH1&
  &4, CCTKH15, CCTKH17, first_order_scheme, CCTKH18
  REAL*8 CCTKH19
  integer, parameter :: cctki_use_CCTKH19 = kind(CCTKH19)
  REAL*8 null_xin
  integer, parameter :: cctki_use_null_xin = kind(null_xin)
  INTEGER*4 N_ang_ev_outside_eq
  integer, parameter :: cctki_use_N_ang_ev_outside_eq = kind(N_ang_ev_outside_eq)
  INTEGER*4 N_ang_ghost_pts
  integer, parameter :: cctki_use_N_ang_ghost_pts = kind(N_ang_ghost_pts)
  INTEGER*4 N_ang_pts_inside_eq
  integer, parameter :: cctki_use_N_ang_pts_inside_eq = kind(N_ang_pts_inside_eq)
  INTEGER*4 N_ang_stencil_size
  integer, parameter :: cctki_use_N_ang_stencil_size = kind(N_ang_stencil_size)
  INTEGER*4 N_radial_pts
  integer, parameter :: cctki_use_N_radial_pts = kind(N_radial_pts)
  INTEGER*4 CCTKH20
  integer, parameter :: cctki_use_CCTKH20 = kind(CCTKH20)
  COMMON /NULLGRIDrest/CCTKH19, null_xin, N_ang_ev_outside_eq, N_ang_ghost_pts, N_ang_pts_inside_eq, N_ang_stencil_size, N_radial_p&
  &ts, CCTKH20
  INTEGER*4 linearized_news
  integer, parameter :: cctki_use_linearized_news = kind(linearized_news)
  COMMON /NULLNEWSrest/linearized_news
    interface
  integer*8 function CCTK_PointerTo (var)
  implicit none
  type(*),dimension(..),TARGET :: var
  end function CCTK_PointerTo
  end interface
  interface
  integer function CCTK_Equals (arg1, arg2)
  implicit none
  integer*8 arg1
  character(*) arg2
  end function CCTK_Equals
  integer function CCTK_MyProc (cctkGH)
  implicit none
  integer*8 cctkGH
  end function CCTK_MyProc
  integer function CCTK_nProcs (cctkGH)
  implicit none
  integer*8 cctkGH
  end function CCTK_nProcs
  integer function CCTK_IsThornActive (name)
  implicit none
  character(*) name
  end function CCTK_IsThornActive
  integer*8 function CCTK_NullPointer ()
  implicit none
  end function CCTK_NullPointer
  end interface
  interface
  INTEGER*4 function MoLRegisterEvolvedGroup (EvolvedIndex, RHSIndex)
  implicit none
  INTEGER*4 EvolvedIndex
  INTEGER*4 RHSIndex
  end function MoLRegisterEvolvedGroup
  end interface

    INTEGER*4, parameter :: izero = 0
    integer, parameter :: ik = kind(izero)

    

    if (verbose.ne.0) then
      call CCTK_Info("NullExact","calculating Ylm's")
    endif

    call rsYlm(2_ik,l_in_Ylm,m_in_Ylm,null_lsh(1),null_lsh(2),zz,Ylm_2)
    call rsYlm(1_ik,l_in_Ylm,m_in_Ylm,null_lsh(1),null_lsh(2),zz,Ylm_1)
    call rsYlm(0_ik,l_in_Ylm,m_in_Ylm,null_lsh(1),null_lsh(2),zz,Ylm_0)

  end subroutine NullExact_PreCalcYlm
